"""Globals.py
"""

# Abstract Network Simulator ('anx')
#
# Copyright 2017 Vladimir Likic
# Copyright Commonwealth of Australia
#
# This software is licensed under the 3 Clause BSD License:
# https://opensource.org/licenses/BSD-3-Clause
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
#
# 3. Neither the name of the copyright holder nor the names of its
# contributors may be used to endorse or promote products derived
# from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.

# version
VERSION = 0
REVISION = 2

# queue monitoring interval
QUEUE_MONITOR_DELTAT = 0.001

#
# Network model keywords- model graph definition keywords
#

MODEL_NAME_KWD = 'model_name'
# node attribute keywords
NODE_TYPE_KWD = 'type'
NODE_PKT_RATE_KWD = 'node_pkt_rate'
# packet processing delay
NODE_PROC_DELAY_KWD = 'node_proc_delay'
# node queue cutoff
NODE_QUEUE_CUTOFF_KWD = 'node_queue_cutoff'
# the interval for checking the queue when
# not locked in processing
NODE_QUEUE_CHECK_KWD = 'node_queue_check'

# link attribute keywords
LINK_CAPACITY_KWD = 'link_capacity'  # link capacity
# delay in packet transmission through the link
LINK_TRANSM_DELAY_KWD = 'link_transm_delay'

# the table of shortest paths
PATH_G_KWD = 'path_G'

#
# packet structure keywords
#
ID = 'id'
TIME_STAMP = 'time_stamp'
SOURCE = 'source'
DEST_NODE = 'dest_node'
HOP_NODE = 'hop_node'
NO_HOPS = 'no_hops'
DEST_TIME_STAMP = 'dest_time_stamp'
NONE = 'none'

#
# suffixes for input files
#
TOPO_SUFFIX = ".topo"
TYPE_SUFFIX = ".type"
PARAM_SUFFIX = ".param"

# suffix for pickling the model
PICKLE_SUFFIX = ".pickle"

# suffixes for output files
NODES_LIST_FILE = 'nodes.dat'
GEN_SUFFIX = '_gen.csv'
FWD_SUFFIX = '_fwd.csv'
DISCARD_SUFFIX = '_discard.csv'
RECV_SUFFIX = '_recv.csv'
QUEUE_SUFFIX = '_queue.csv'

#
# define verbose levels
#
VERB_NO = 0
VERB_LO = 1
VERB_HI = 2
VERB_EX = 3

#
# simulation progress bar
#
BAR_LENGTH = 40
